Index: c/src/exec/posix/include/devctl.h
===================================================================
--- c/src/exec/posix/include/devctl.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/devctl.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_DEVICE_CONTROL_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 #if defined(_POSIX_DEVICE_CONTROL)
@@ -27,4 +31,8 @@
 #endif
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: c/src/exec/posix/include/intr.h
===================================================================
--- c/src/exec/posix/include/intr.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/intr.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -10,5 +10,9 @@
 #define __POSIX_INTERRUPTS_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 #include <sys/types.h>
 #include <sys/time.h>
@@ -69,4 +73,8 @@
 #endif
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: c/src/exec/posix/include/mqueue.h
===================================================================
--- c/src/exec/posix/include/mqueue.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/mqueue.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_MESSAGE_QUEUE_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 #if defined(_POSIX_MESSAGE_PASSING)
@@ -142,4 +146,8 @@
 #endif /* _POSIX_MESSAGE_PASSING */
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: c/src/exec/posix/include/pthread.h
===================================================================
--- c/src/exec/posix/include/pthread.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/pthread.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -6,4 +6,8 @@
 #ifndef __PTHREAD_h
 #define __PTHREAD_h
+
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 #include <sys/features.h>
@@ -497,4 +501,9 @@
 
 #endif /* defined(_POSIX_THREADS) */
+
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: c/src/exec/posix/include/sched.h
===================================================================
--- c/src/exec/posix/include/sched.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/sched.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,4 +7,8 @@
 #ifndef __POSIX_SCHEDULING_h
 #define __POSIX_SCHEDULING_h
+
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 #include <sys/features.h>
@@ -84,4 +88,8 @@
 #endif /* _POSIX_THREADS or _POSIX_PRIORITY_SCHEDULING */
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: c/src/exec/posix/include/semaphore.h
===================================================================
--- c/src/exec/posix/include/semaphore.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/semaphore.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_SEMAPHORE_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 #if defined(_POSIX_SEMAPHORES)
@@ -105,4 +109,8 @@
 #endif   /* _POSIX_SEMAPHORES */
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: c/src/exec/posix/include/unistd.h
===================================================================
--- c/src/exec/posix/include/unistd.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ c/src/exec/posix/include/unistd.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_UNISTD_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 /*
@@ -86,4 +90,8 @@
 );
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include */
Index: cpukit/posix/include/devctl.h
===================================================================
--- cpukit/posix/include/devctl.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ cpukit/posix/include/devctl.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_DEVICE_CONTROL_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 #if defined(_POSIX_DEVICE_CONTROL)
@@ -27,4 +31,8 @@
 #endif
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: cpukit/posix/include/intr.h
===================================================================
--- cpukit/posix/include/intr.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ cpukit/posix/include/intr.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -10,5 +10,9 @@
 #define __POSIX_INTERRUPTS_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 #include <sys/types.h>
 #include <sys/time.h>
@@ -69,4 +73,8 @@
 #endif
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: cpukit/posix/include/mqueue.h
===================================================================
--- cpukit/posix/include/mqueue.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ cpukit/posix/include/mqueue.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_MESSAGE_QUEUE_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 #if defined(_POSIX_MESSAGE_PASSING)
@@ -142,4 +146,8 @@
 #endif /* _POSIX_MESSAGE_PASSING */
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: cpukit/posix/include/sched.h
===================================================================
--- cpukit/posix/include/sched.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ cpukit/posix/include/sched.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,4 +7,8 @@
 #ifndef __POSIX_SCHEDULING_h
 #define __POSIX_SCHEDULING_h
+
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 #include <sys/features.h>
@@ -84,4 +88,8 @@
 #endif /* _POSIX_THREADS or _POSIX_PRIORITY_SCHEDULING */
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
Index: cpukit/posix/include/semaphore.h
===================================================================
--- cpukit/posix/include/semaphore.h	(revision 3aeaca90710c97cb5e4116e123fa954220c02d94)
+++ cpukit/posix/include/semaphore.h	(revision c7aa9d6ff8913785a50b94f8a967b084d61d6af3)
@@ -7,5 +7,9 @@
 #define __POSIX_SEMAPHORE_h
 
-#include <rtems/posix/features.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <sys/features.h>
 
 #if defined(_POSIX_SEMAPHORES)
@@ -105,4 +109,8 @@
 #endif   /* _POSIX_SEMAPHORES */
 
+#ifdef __cplusplus
+}
+#endif
+
 #endif
 /* end of include file */
